diff --git a/attic/make-official-release.sh b/attic/make-official-release.sh
new file mode 100755
index 000000000..4355c5733
--- /dev/null
+++ b/attic/make-official-release.sh
@@ -0,0 +1,28 @@
+#!/bin/bash
+
+#
+# This script signs an installer, creates its .NFO file, and
+# copies it to a destination directory. This in turn can be
+# uploaded to the official ZeroTier Networks update site for
+# auto-updating binary distribution users.
+#
+# It's in attic/ because end-users won't find it particularly
+# useful. You must have the ZeroTier One official signing
+# identity secret keys to sign binary releases for auto-update,
+# and of course you'd also have to upload it to our servers.
+#
+
+# Build the app and the installer, then run this from the root
+# of the source tree. It'll need the zerotier-idtool symlink
+# that will be placed there after a build, too.
+
+export PATH=/bin:/usr/bin:/sbin:/usr/sbin
+
+if [ "$#" -ne 2 ]; then
+	echo "Usage: $0 <path to secret signing identity> <path to destination folder for .nfo and installer>"
+	exit 1
+fi
+
+secret="$1"
+dest="$2"
+
diff --git a/attic/update-dummy/README.txt b/attic/update-dummy/README.txt
new file mode 100644
index 000000000..a85f42000
--- /dev/null
+++ b/attic/update-dummy/README.txt
@@ -0,0 +1,3 @@
+This is a do-nothing placebo software update for internal testing. It's a
+shell script that just prints a simple message and an .NFO file that signs
+it as official.
diff --git a/make-mac.mk b/make-mac.mk
index 06a8a2aec..3af72d40d 100644
--- a/make-mac.mk
+++ b/make-mac.mk
@@ -5,6 +5,14 @@ INCLUDES=
 DEFS=
 LIBS=
 
+# Disable codesign since open source users will not have ZeroTier's ADC certs
+CODESIGN=echo
+
+ifeq ($(ZT_OFFICIAL_RELEASE),1)
+	ZT_AUTO_UPDATE=1
+	DEFS+=-DZT_OFFICIAL_RELEASE 
+	CODESIGN=codesign
+endif
 ifeq ($(ZT_AUTO_UPDATE),1)
 	DEFS+=-DZT_AUTO_UPDATE 
 endif
@@ -41,7 +49,12 @@ mac-ui: FORCE
 	cd build-ZeroTierUI-release ; ../../Qt/bin/qmake ../ZeroTierUI/ZeroTierUI.pro ; make -j 4
 	strip "build-ZeroTierUI-release/ZeroTier One.app/Contents/MacOS/ZeroTier One"
 	cp -Rv ZeroTierUI/helpers "build-ZeroTierUI-release/ZeroTier One.app/Contents/Resources"
-#	cd build-ZeroTierUI-release ; codesign -f -s '3rd Party Mac Developer Application: ZeroTier Networks LLC' "ZeroTier One.app"
+	$(CODESIGN) -f -s '3rd Party Mac Developer Application: ZeroTier Networks LLC' "build-ZeroTierUI-release/ZeroTier One.app/Contents/Resources/helpers/mac/ZeroTier One (Authenticate).app"
+	$(CODESIGN) -f -s '3rd Party Mac Developer Application: ZeroTier Networks LLC' "build-ZeroTierUI-release/ZeroTier One.app/Contents/Resources/helpers/mac/ZeroTier One (Install).app"
+	$(CODESIGN) -f -s '3rd Party Mac Developer Application: ZeroTier Networks LLC' "build-ZeroTierUI-release/ZeroTier One.app"
+	$(CODESIGN) -vvv "build-ZeroTierUI-release/ZeroTier One.app/Contents/Resources/helpers/mac/ZeroTier One (Authenticate).app"
+	$(CODESIGN) -vvv "build-ZeroTierUI-release/ZeroTier One.app/Contents/Resources/helpers/mac/ZeroTier One (Install).app"
+	$(CODESIGN) -vvv "build-ZeroTierUI-release/ZeroTier One.app"
 
 install-mac-tap: FORCE
 	mkdir -p /Library/Application\ Support/ZeroTier/One